unit Unit1;

{
 bridges - hashi - puzzle helper / solver

 events, control, reporting

 28-01-2021
 04-02-2021 removed HVarrays for bridge crossing test
 11-02-2021 added gsSolved gamestate
 12-02-2021 V1.0
 12-02-2021 version without DavArray- and RotationBtn components
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, {Vcl.ComCtrls, dav7components, dav7RotationBtn,}
  shellAPI, ComCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    msglabel: TLabel;
    Label1: TLabel;
    gamesizelabel: TStaticText;
    clearBtn: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Image1: TImage;
    InstBrLabel: TStaticText;
    maxBrLabel: TStaticText;
    Label2: TLabel;
    Label3: TLabel;
    progressbox: TPaintBox;
    Label4: TLabel;
    UpDown1: TUpDown;
    warningBtn: TSpeedButton;
    hintBtn: TSpeedButton;
    solutionBtn: TSpeedButton;
    openBtn: TSpeedButton;
    saveBtn: TSpeedButton;
    newBtn: TSpeedButton;
    playBtn: TSpeedButton;
    helpBtn: TSpeedButton;
    exitBtn: TSpeedButton;
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure clearBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure progressboxPaint(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure warningBtnClick(Sender: TObject);
    procedure openBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

 TMenubutton = (mmOpen,mmSave,mmNew,mmPlay,mmHelp,mmExit,mmOff);

const formheader = 'hashi:';

procedure newGameLoaded;

var Form1: TForm1;
    menubutton  : TMenubutton;
    warningFlag : boolean;
    hintflag    : boolean;

implementation

{$R *.dfm}

uses paint_unit,io_unit,game_unit,solve_unit,progress_unit;

type Tcolormessage = record
                      col : dword;
                      mes : string;
                     end;
     Tcontrolmessage = (cmActivate,cmNewBtn,cmPlayBtn,cmBridgeAdded,
                        cmBridgeDeleted,cmClearBtnClick,cmHint,
                        cmWarningBtn,cmHintBtn,cmSolveBtn,cmSolved,
                        cmSpaceKey,cmEscapeKey,cmWarningBtnOn,cmWarningBtnOff,
                        cmHintBtnOn,cmHintBtnOff,cmSolution,cmSolveBtnOn,
                        cmSolveBtnOff,cmEndOfSearch);
     TGamestate      = (gsInitial,gsNew,gsPlaying,gsHintWaiting,gsSolving,
                        gsSolved);
     TBridgeEnds = record
                    Is1 : byte;//islands at bridge ends
                    Is2 : byte;
                   end;

const msg : array[1..17] of Tcolormessage =
  ((col:$000000;mes:'welcome at the hashi / bridges puzzle helper / solver'),//1
   (col:$000000;mes:'set game size, enter islands...'),                      //2
   (col:$000000;mes:'add bridge...'),                                        //3
   (col:$000000;mes:'add new bridge...'),                                    //4
   (col:$a00000;mes:'Congratulations: you solved the game !'),               //5
   (col:$0000c0;mes:'cannot add all bridges'),                               //6
   (col:$0000c0;mes:'isolated group'),                                       //7
   (col:$800080;mes:'hint stop. Press <SPACE> to add bridge, <ESC> to ignore'),//8
   (col:$0000c0;mes:'cannot solve game: odd number of bridges.'),            //9
   (col:$ff0000;mes:'<SPACE> for more hints'),                              //10
   (col:$000000;mes:'No hints. Add bridge'),                                //11
   (col:$000000;mes:'No solution.'),                                   //12
   (col:$ff0000;mes:'Searching for solution...<ESC> to stop'),              //13
   (col:$0000ff;mes:'Too many bridges, no search.'),                        //14
   (col:$0000ff;mes:'warning active, cannot report hints'),                 //15
   (col:$000000;mes:'search terminated'),                                   //16
   (col:$ff0000;mes:'help info not yet implemented'));                      //17

var gamestate : Tgamestate;
    hint : Thint;
    newLine : TLine;
    orgX,orgY : byte;//for bridge selection during playing
    painting : boolean;
    solutionNr : byte;
    maxcombinations : double;
    searchContinueFlag : boolean;

procedure controlmessage(cm : Tcontrolmessage);forward;
procedure warningreport1(nr : byte);forward;
procedure warningreport2(grp : byte);forward;
procedure hintreport(const h : THint);forward;

procedure Gmessage(nr : byte);
begin
 with form1.msglabel do
  begin
   font.color := msg[nr].col;
   caption := msg[nr].mes;
  end;
end;

procedure setgamesize;
//from rotationbutton position
var offset : word;
    s : string;
begin
 gamesize := form1.UpDown1.position;
 with form1.PaintBox1 do
  begin
   width := 40*gamesize;
   height := width;
   offset := ((15-gamesize)*40) shr 1;
   left := offset + 10;
   top := offset + 70;
  end;
 s := inttostr(gamesize);
 s := s + ' x '+s;
 form1.gamesizelabel.Caption := s;
 with Gmap do
  begin
   width := form1.PaintBox1.Width;
   height := width;
  end;
end;

procedure EnableHelpBtns(bv : boolean);
//set enabled true or false
begin
 with form1 do
  begin
   warningBtn.down := false;
   HintBtn.Down := false;
   solutionBtn.Down := false;
   warningBtn.Enabled := bv;
   hintBtn.enabled := bv;
   solutionBtn.Enabled := bv;
  end;
end;

procedure menuBtnRelease;
begin
 with form1 do
  case menubutton of
   mmOpen : OpenBtn.down := false;
   mmSave : SaveBtn.Down := false;
   mmnew  : NewBtn.Down := false;
   mmPlay : PlayBtn.Down := false;
   mmHelp : helpBtn.Down := false;
   mmExit : ExitBtn.Down := false;
  end;
 menubutton := mmOff;
end;

//--checks for adding of new  island --

function noneighbours(x,y : byte) : boolean;
//called before placing new island
//neighbourfields must be ftNone. No bridges, no islands
var i : byte;
 OK : boolean;
begin
 OK := true;
 i := 0;
 repeat
  inc(i);
  case i of
   1 : if (x > 1) then
         with game[x-1,y] do OK := (ftype = ftNone) or (ftype = ftVbridge);
   2 : if (x < gamesize) then
         with game[x+1,y] do OK := (ftype = ftNone) or (ftype = ftVBridge);
   3 : if (y > 1) then
         with game[x,y-1] do OK := (ftype = ftNone) or (ftype = ftHBridge);
   4 : if (y < gamesize) then
         with game[x,y+1] do OK := (ftype = ftNone) or (ftype = ftHBridge);
  end;
 until (i = 4) or (OK = false);
 result := OK;
end;

function BridgeSpace(x,y : byte) : byte;
//called for bridge count increment of island (entering new game)
//get maximal bridge count of field (x,y)
begin
 result := 4;
 if (x > 2) and (x < gamesize-1) then inc(result,2);
 if (y > 2) and (y < gamesize-1) then inc(result,2);
end;

function Connectedbridges(x,y : byte) : byte;
begin
 result := 0;
 if x > 2 then
  with game[x-1,y] do
   if ftype = ftHbridge then result := result + brCount;
 if x < gamesize - 1 then
  with game[x+1,y] do
   if ftype = ftHbridge then result := result + brCount;
 if y > 2 then
  with game[x,y-1] do
   if ftype = ftVbridge then result := result + brCount;
 if y < gamesize - 1 then
  with game[x,y+1] do
   if ftype = ftVbridge then result := result + brCount;
end;

//-- searches on game[ ] for neighbours

function searchleft(var n : byte; x,y : byte) : boolean;
//search left of x,y for island
begin
 result := false;
 while (x > 1) and (result = false) do
  begin
   dec(x);
   case game[x,y].ftype of
    ftVbridge : x := 0;
    ftIsland : result := true;
   end;
  end;
 if result = true then n := x;
end;

function searchRight(var n : byte; x,y : byte) : boolean;
begin
 result := false;
 while (x < gamesize) and (result = false) do
  begin
   inc(x);
   case game[x,y].ftype of
    ftVbridge : x := 100;
    ftIsland : result := true;
   end;
  end;
 if result = true then n := x;
end;

function searchUP(var n : byte; x,y : byte) : boolean;
begin
 result := false;
 while (y > 1) and (result = false) do
  begin
   dec(y);
   case game[x,y].ftype of
    ftHbridge : y := 0;
    ftIsland : result := true;
   end;
  end;
 if result = true then n := y;
end;

function searchDown(var n : byte; x,y : byte) : boolean;
begin
 result := false;
 while (y < gamesize) and (result = false) do
  begin
   inc(y);
   case game[x,y].ftype of
    ftHbridge : y := 100;
    ftIsland : result := true;
   end;
  end;
 if result = true then n := y;
end;

function XY2line(var line : Tline; fx,fy : byte) : boolean;
//find line between x1,y1  and x2 y2 through fx,fy
//return true is found
//search horizontal line first
//consider bridges
var p1,p2 : byte;
begin
 result := false;
 line.valid := false;
 if game[fx,fy].ftype = ftIsland then exit;
//
 if (game[fx,fy].ftype = ftHbridge) or (game[fx,fy].ftype = ftNone) then
  if searchleft(p1,fx,fy) and searchright(p2,fx,fy) then
   with line do
    begin
     x1 := p1; y1 := fy; x2 := p2; y2 := fy;
     result := true;
     line.valid := true;
     exit;
    end;
//
 if (game[fx,fy].ftype = ftVbridge) or (game[fx,fy].ftype = ftNone) then
  if searchUp(p1,fx,fy) and searchDown(p2,fx,fy) then
   with line do
    begin
     x1 := fx; y1 := p1; x2 := fx; y2 := p2;
     result := true;
     line.valid := true;
    end;
end;

function makeline(px1,py1,px2,py2 : byte) : TLine;
//px1,py1 are coords of island
//px2,py2 make direction
var dir : byte;
    hor,vert : boolean;
begin
 dir := 0;
 with result do
  begin
   valid := false;
   if game[px1,py1].ftype <> ftIsland then exit;  //start line at island
//
   hor := (px1 <> px2) and (py1 = py2);
   vert := (px1 = px2) and (py1 <> py2);
   if hor = vert then exit;
//
   if hor then
    if (px1 < px2) then dir := 1 else dir := 3;
   if vert then
    if (py1 < py2) then dir := 4 else dir := 2;
   case dir of
    1 : begin
         x1 := px1; y1 := py1; y2 := py1;
         valid := searchright(x2,px1,py1);
        end;
    2 : begin
         x1 := px1; x2 := px1; y2 := py1;
         valid := searchUp(y1,px1,py1);
        end;
    3 : begin
         x2 := px1; y1 := py1; y2 := py1;
         valid := searchLeft(x1,px1,py1);
        end;
    4 : begin
         x1 := px1; y1 := py1; x2 := px1;
         valid := searchDown(y2,px1,py1);
        end;
   end;//case
  end; //with result
end;

function checksolution : boolean;
begin
 result := false;
 if maxbridgecount = bridgecount then
  result := checkGameSolved;
end;

function checkwarnings(var warning : Twarning) : boolean;
begin
 result := testwarnings(warning);
 if result = false then clearRedIsland; 
end;

function checkhints(var ht : THint) : boolean;
var warning : Twarning;
begin
 result := false;
 if testwarnings(warning) then begin
                                Gmessage(15);
                                exit;
                               end;
 result := testhints(ht);
end;

procedure installhint;
var nb,h,i : byte;
    line : Tline;
begin
 with island[hint.isNR] do
  begin
   line.x1 := x;
   line.y1 := y;
   nb := neighbrs[hint.dir];
  end;
 with island[nb] do
  begin
   line.x2 := x;
   line.y2 := y;
  end;
 with line do          //sort coords
  begin
   if x1 > x2 then begin
                    h := x1; x1 := x2; x2 := h;
                   end;
   if y1 > y2 then begin
                    h := y1; y1 := y2; y2 := h;
                   end;
  end;
 for i := 1 to hint.brs do addbridge(line);
 paintgame;
end;

procedure solveProc;
var srch : byte;
    ccu  : double;
    perc : single;
label loop;
begin
 Gmessage(13);
 application.ProcessMessages;

loop:

 application.ProcessMessages;
 srch := searchsolution;
 case srch of
  0 : begin
       Gmessage(12);//no more solutions
       controlmessage(cmEndOfSearch);
      end;
  1 : begin
       inc(solutionNr);
       form1.msglabel.Caption := 'solution '+inttostr(solutionNr)+
       '; <SPACE> for more solutions, <ESCAPE> to stop';
      end;
  2 : begin
       ccu := getCCupdates;
       perc := 100*ccu/maxCombinations;
       setProgress(perc);
       if searchContinueFlag then goto loop
        else controlmessage(cmSolveBtnOff);
      end;
 end;//case
 paintgame;
end;

function InitSolving : boolean;
var i,n,k : byte;
begin
 resetProgressbox;
 solutionNr := 0;
 if makebridgelist then
  begin
   clearCC;
   getSolveBridgeData(n,k);
   maxcombinations := 1;
   for i := k+1 to n do maxcombinations := maxcombinations * i/(i-k);
   result := true;
   searchcontinueFlag := true;
  end
  else begin
        result := false;
        Gmessage(14);
       end;
end;

//-- called by mouse events ---

procedure newmousedown(x,y : byte; button : TmouseButton);
//mouse down in new game state
begin
 with game[x,y] do
  case ftype of
   ftNone : if (Button = mbleft) then
             if noneighbours(x,y) then
              begin
               ftype := ftIsland;
               brCount := 1;
              end;
  ftIsland : begin
              if button = mbLeft then
               begin
                if brCount < BridgeSpace(X,Y) then inc(brCount);
               end
               else
                if brCount > connectedbridges(x,y) then dec(brCount);
               if brCount = 0 then game[X,Y].ftype := ftNone;
             end;
 end;
 paintField(X,Y);
 Gmapfield2box(X,Y);
end;

procedure playmousedown(x,y : byte; button : Tmousebutton);
//mouse down in playing state
begin
 if newline.valid then
  begin
   if button = mbLeft then
    begin
     if addbridge(newline) then controlmessage(cmBridgeAdded);
    end
    else
     if deleteBridge(newline) then controlmessage(cmBridgedeleted);
   newline.valid := false;
  end
   else
    if game[x,y].ftype = ftIsland then begin
                                        orgX := x;
                                        orgY := y;
                                        painting := true;
                                       end;
end;

procedure paintmousemove(x,y : byte);
//mouse move while painting line
//x,y is field coord
//if painting a line
begin
 if (x = orgX) and (y =  orgY) then exit;
//
 newline := makeline(orgX,orgY,x,y);
 if newline.valid then begin
                        newline.color := $ff0000;
                        paintline(newline);
                       end;
end;

procedure nonpaintmousemove(x,y : byte);
//mouse move while not painting
//x,y is field coord
begin
 if (game[x,y].ftype = ftHbridge) or (game[x,y].ftype = ftVbridge) then
  begin
   XY2line(newline,x,y);
   if newline.valid then paintline(newline);
  end else begin
            clearline;
            newline.valid := false;
           end;
end;

//-- mouse events

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if (gamestate = gsPlaying) or (gamestate = gsSolved) then
  begin
   x := (x div 40) + 1;
   y := (y div 40) + 1;
   if (x < 0) or  (x > gamesize) or (y < 0) or (y > gamesize) then exit;
//
   if painting then paintmousemove(x,y)
    else nonpaintmousemove(x,y);
  end;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 x := (x div 40) + 1;
 y := (y div 40) + 1;
 case gamestate of
  gsNew     : NewmouseDown(x,y,button);
  gsPlaying,
  gsSolved : Playmousedown(x,y,button);
 end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 case gamestate of
  gsPlaying,
  gsSolved  : if painting and newline.valid then
               begin
                if button = mbLeft then
                 begin
                  if addbridge(newline) then controlmessage(cmBridgeAdded);
                 end
                else
                 if deleteBridge(newline) then controlmessage(cmBridgedeleted);
                clearline;
                newline.valid := false;
                painting := false;
               end;
  gsNew         : ;
  gsHintWaiting : ;
 end;//case
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
  VK_SPACE  : controlmessage(cmSpaceKey);
  VK_ESCAPE : controlmessage(cmEscapeKey);
 end;
 key := 0;
end;

//-- button changes

procedure TForm1.warningBtnClick(Sender: TObject);
//also hint, solution button tags 0,1,2
var spBtn : TSpeedbutton;
begin
 spBtn := TSpeedbutton(sender);
 if spBtn.down = false then
  case spBtn.Tag of
   0 : controlmessage(cmWarningBtnOff);
   1 : controlmessage(cmHintBtnOff);
   2 : controlmessage(cmSolveBtnOff);
  end
  else
  case spBtn.tag of
   0 : begin
        warningflag := true;
        controlmessage(cmWarningBtnOn);
       end;
   1 : begin
        hintflag := true;
        controlmessage(cmhintBtnOn);
       end;
   2 : begin
        solutionNr := 0;
        controlmessage(cmSolveBtnOn);
       end;
  end;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 clearedges(paintbox1);
 setgamesize;
 cleargame;
 paintgame;
 paintedges(paintbox1,$000000);
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 activecontrol := nil;
 controlmessage(cmClearBtnClick);
end;

//-- menubutton --

procedure TForm1.openBtnClick(Sender: TObject);
//all menu buttons
var spBtn : TSpeedbutton;
begin
 spBtn := TSpeedbutton(sender);
 if spBtn.down then
  begin
   menubutton := Tmenubutton(spBtn.tag);
   case menubutton of
    mmOpen : if (gamestate <> gsInitial) then
              begin
               openGame;
               menuBtnRelease;
               newBtn.Down := true;
               menuButton := mmNew;
               gamestate := gsNew;
              end;
    mmSave : if (gamestate <> gsInitial) then
              begin
               savegame;
               menuBtnRelease;
              end;
    mmNew  : Controlmessage(cmNewBtn);
    mmPlay : Controlmessage(cmPlayBtn);
    mmHelp : Gmessage(17);
    mmExit : application.Terminate;
   end;
  end;
end;

//-- paint

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges(paintbox1,$000000);
 paintedges(progressbox,$000000);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.Canvas.Draw(0,0,Gmap);
end;

procedure TForm1.progressboxPaint(Sender: TObject);
begin
 repaintProgressbox;
end;

//-- create, destroy

procedure TForm1.FormCreate(Sender: TObject);
begin
 Gmap := Tbitmap.Create;
 with Gmap do with canvas do
  begin
   pixelformat := pf32bit;
   font.Name := 'arial';
   font.Height := 18;
   brush.Color := $ffffff;
   font.Color := 0;
  end;
 setgamesize;
 enablehelpBtns(false);
 menubutton := mmOff;
 activecontrol := nil;
 gamestate := gsInitial;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 controlmessage(cmActivate);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Gmap.Free;
end;

//-------------------------------------

procedure newGameLoaded;
//called from open (io unit)
begin
 form1.UpDown1.position := gamesize;
 clearEdges(form1.PaintBox1);
 setgamesize;
 paintGame;
 paintEdges(form1.PaintBox1,0);
 buildIslandlist;
 with form1 do
  begin
   InstBrLabel.Caption := inttostr(bridgecount);
   maxBrLabel.caption := inttostr(maxbridgecount);
  end;
end;

//-- warning and hint reports --

procedure warningreport1(nr : byte);
//island cannot attach all bridges
begin
 Gmessage(6);
 paintredIsland(nr);
end;

procedure warningreport2(grp : byte);
begin
 Gmessage(7);
 LightGroup(grp);
end;

procedure hintReport(const h : THint);
//process hints reported in H
var line : Tline;
    nbr : byte;
begin
 with H do  with line do
  begin
   x1 := island[isNr].x;
   y1 := island[isNr].y;
   case dir of
    1 : begin
         nbr := island[isNr].neighbrs[1];
         x2 := island[nbr].x;
         y2 := y1;
        end;
    2 : begin
         x2 := x1;
         nbr := island[isNr].neighbrs[2];
         y2 := island[nbr].y;
        end;
    3 : begin
         y2 := y1;
         nbr := island[isNr].neighbrs[3];
         x2 := island[nbr].x;
        end;
    4 : begin
         x2 := x1;
         nbr := island[isNr].neighbrs[4];
         y2 := island[nbr].y;
        end;
   end;//case
   color := $ff00ff;
   paintline(line);
  end;//with H
end;

procedure delay(mst : word);
//delay mst milliseconds
var t1 : dword;
begin
 t1 := gettickcount + mst;
 while gettickcount < t1 do application.ProcessMessages;
end;

procedure ClearWarnings;
begin
 form1.warningBtn.down := false;
 warningflag := false;
 clearRedIsland;
 form1.msglabel.Caption := '';
 Gmessage(3);
end;

procedure clearHints;
begin
 form1.hintBtn.down := false;
 hintflag := false;
 hint.valid := false;
 Gmessage(3);
 form1.msglabel.Caption := '';
 copymap2Box;
end;

procedure InitActivate;
begin
 with form1 do
  begin
   Gmessage(1);
   Caption := formheader;
   delay(2000);
   Gmessage(2);
   NewBtn.Down := true;
   menubutton := mmNew;
  end;
 clearGame;
 paintgame;
end;

procedure initNewState;
begin
 with form1 do
  begin
   UpDown1.enabled := true;
   EnableHelpBtns(false);
   Gmessage(2);
   paintgame;
  end;
end;

procedure initplaystate;
begin
 with form1 do
  begin
   UpDown1.enabled := false;
   EnableHelpBtns(true);
   Gmessage(3);
   if buildIslandlist = false then
    begin
     Gmessage(9);
    end
     else begin
           maxBrLabel.Caption := inttostr(maxbridgecount);
           InstBrLabel.caption := inttostr(bridgecount);
          end;
  end;
end;

procedure procWarningsAndHints;
var warning : Twarning;
begin
if warningFlag then
  if checkwarnings(warning) then
   begin
    case warning.wtype of
     1 : warningreport1(warning.nr);
     2 : warningreport2(warning.nr);
    end;
    exit;
   end;
 if hintflag then
  if testhints(hint) then controlmessage(cmHint)
   else Gmessage(11);
end;

procedure procbridgeAdded;
begin
 newline.valid := false;
 paintgame;
 form1.InstBrLabel.Caption := inttostr(bridgecount);
 if checksolution then
  begin
   controlmessage(cmSolution);
   exit;
  end;
 procWarningsAndHints;
end;

procedure procBridgeDeleted;
begin
 Gmessage(4);
 newline.valid := false;
 paintgame;
 form1.InstBrLabel.Caption := inttostr(bridgecount);
 procWarningsAndHints;
end;

procedure procNewClear;
begin
 cleargame;
 paintgame;
 Gmessage(2);
 with form1 do
  begin
   InstBrLabel.Caption := '';
   maxBrLabel.Caption := '';
  end;
end;

procedure procPlayClear;
begin
 clearBridges;   //builds new island list
 paintgame;
 Gmessage(3);
 bridgecount := 0; //--> game unit
 form1.InstBrLabel.Caption := '';
 resetprogressbox;
end;

procedure procNewHint;
begin
 Hintreport(hint);
 Gmessage(8);
end;

procedure procAddHint;
begin
 installHint;
 hint.valid := false;
 copymap2box;
 Gmessage(10);
 form1.InstBrLabel.caption := inttostr(bridgecount);
 if checksolution then
  begin
   controlmessage(cmSolution);
   exit;
  end;
 procWarningsAndHints;
end;

procedure procIgnoreHint;
begin
 hint.valid := false;
 hintflag := false;
 copymap2box;
 form1.hintBtn.Down := false;
 Gmessage(3);
end;

procedure procgamesolved;
begin
 Gmessage(5);
end;

procedure procSolveTermination;
begin
 searchcontinueflag := false;
 form1.solutionBtn.Down := false;
 Gmessage(16);
end;

procedure procEndOfSearch;
begin
 searchcontinueFlag := false;
 form1.solutionBtn.Down := false;
 Gmessage(12);
end;

procedure resetSolveBtn;
begin
 with form1 do
  begin
   solutionBtn.Down := false;
   if warningflag then warningBtn.Down := true;
   if hintflag then hintBtn.Down := true;
  end;
end;

//-- central game control --

procedure controlmessage(cm : Tcontrolmessage);
//control of events
//acc. to gamestates: (gsNew,gsPlaying,gsWaitHint,gsSolved,gsEnd);
begin
 case gamestate of
  gsInitial : case cm of
               cmActivate : begin
                             initActivate;
                             gamestate := gsNew;
                            end;
              end;
  gsNew     : case cm of
               cmPlayBtn : begin
                            if warningflag then clearwarnings;
                            if hintflag then clearhints;
                            initplaystate;
                            gamestate := gsPlaying;
                           end;
               cmClearBtnClick : procNewClear;
              end;
  gsPlaying : case cm of
               cmNewBtn : begin
                           initNewState;
                           gamestate := gsNew;
                          end;
               cmBridgeAdded : begin
                                procBridgeAdded;
                               end;
               cmBridgeDeleted : begin
                                  procBridgeDeleted;
                                 end;
               cmClearBtnClick : begin
                                  if warningflag then clearwarnings;
                                  if hintflag then clearhints;
                                  procPlayClear;
                                 end;
               cmHint          : begin
                                  gamestate := gsHintWaiting;
                                  procNewHint;
                                 end;
               cmSpaceKey     : procWarningsAndHints;
               cmWarningBtnOn : begin
                                 if hintflag then clearHints;
                                 warningFlag :=true;
                                 procWarningsAndHints;
                                end;
               cmWarningBtnOff : clearWarnings;
               cmHintBtnOn    : begin
                                 if warningflag then clearWarnings;
                                 hintflag := true;
                                 procWarningsAndHints;
                                end;
               cmHintBtnOff   : clearHints;
               cmSolution     : begin
                                 gamestate := gsSolved;
                                 if hintflag then clearHints;
                                 procGameSolved;
                                end;
               cmSolveBtnOn   : begin
                                 if initsolving then
                                  begin
                                   if warningflag then clearWarnings;
                                   if hintflag then clearHints;
                                   gamestate := gsSolving;
                                   solveproc;
                                  end;
                                end;
              end;
  gsHintWaiting : begin
                   case cm of
                    cmSpaceKey  : begin
                                   gamestate := gsPlaying;
                                   procAddHint;
                                  end;
                    cmEscapeKey : begin
                                   gamestate := gsPlaying;
                                   procIgnoreHint;
                                  end;
                    cmSolution  : begin
                                   gamestate := gsPlaying;
                                   procGameSolved;
                                  end;
                    cmSolveBtnOn : resetSolveBtn;
                    cmHintBtnOff : begin
                                    gamestate := gsPlaying;
                                    clearHints;
                                   end;
                   end;
                  end;
  gsSolving      : begin
                    case cm of
                     cmEscapeKey : begin
                                    gamestate := gsPlaying;
                                    procSolveTermination;
                                   end;
                     cmSpaceKey  : solveProc;
                     cmSolveBtnOff : begin
                                      gamestate := gsPlaying;
                                      procSolveTermination;
                                     end;
                     cmEndOfSearch : begin
                                      gamestate := gsPlaying;
                                      procEndOfSearch;
                                     end;
                    end;//case
                   end;
  gsSolved       : begin
                    case cm of
                     cmBridgeDeleted : begin
                                        gamestate := gsPlaying;
                                        procBridgeDeleted;
                                       end;
                     cmClearBtnClick : begin
                                        gamestate := gsPlaying;
                                        if warningflag then clearwarnings;
                                        if hintflag then clearhints;
                                        procPlayClear;
                                       end;
                    end;//case
                   end;
 end;//case
 end;

procedure TForm1.Image1Click(Sender: TObject);
//DavData logo
begin
 ShellExecute(0,'open','http://www.davdata.nl/math', nil, nil, SW_SHOWNORMAL);
end;

end.


