unit io_unit;

{$MODE Delphi}

{ file format
  0..4 'HASHI!' + #0
  6 : gamesize
  7.......  node type + description
  ....
  n : #ff = end of list
}

interface

uses sysutils;

procedure openGame;
procedure saveGame;

implementation

uses Unit1,game_unit;

const fileheader = 'HASHI!_';

var f : file;
    fname : string;
    buffer : array[0..1000] of byte;
    bix : word;
    Xferred : integer;
    XferOK : boolean;

procedure saveGame;
var i,j : byte;
    w : word;
    s,t : string;
begin
 form1.msglabel.Font.Color := 0;
 for w := 0 to 1000 do buffer[w] := 0;
 bix := 0;
 for i := 1 to length(fileheader) do
  begin
   buffer[bix] := byte(fileheader[i]);
   inc(bix);
  end;
  buffer[bix] := gamesize;
  inc(bix);
  for j := 1 to gamesize do
   for i := 1 to gamesize do
    with game[i,j] do
     begin
      buffer[bix] := byte(fType);
      buffer[bix+1] := brCount;
      //0,0
      inc(bix,4);
     end;
  buffer[bix] := $ff; //end of file marker
  inc(bix);
//
 with form1.savedialog1 do
  begin
   filename := fname;
   if execute then
    begin
     XferOK := false;
     s := extractfilepath(filename);
     t := extractfilename(filename);
     s := s + fileheader + t;
     filename := s;
     try
      assignfile(f,filename);
      rewrite(f,1);
      blockwrite(f,buffer,bix,Xferred);
      XferOK := Xferred = bix;
     finally
      closefile(f);
     end;
     if XferOK then
      begin
       form1.msglabel.Caption := 'game saved';
       fname := extractfilename(filename);
       delete(fname,1,7);
       form1.Caption := formheader + fname;
      end
      else form1.msglabel.Caption := 'write error';
    end;
  end;
end;

procedure openGame;
var w : word;
    s : string;
    XFOK : boolean;
    i,j : byte;
begin
 form1.msglabel.Font.Color := 0;
 for w := 0 to 1000 do buffer[w] := 0;
 with form1.OpenDialog1 do
  if execute then
   begin
    if fileExists(filename) = false then
     begin
      form1.msglabel.Caption := 'file not found';
      exit;
     end;
    s := extractfilename(filename);
    fname := s;
    s := copy(s,1,7);
    delete(fname,1,7);
    if s <> fileheader then
     begin
      form1.msglabel.Caption := 'unrecognized file name';
      exit;
     end;
    clearGame;
    try
     XFOK := false;
     assignfile(f,filename);
     reset(f,1);
     blockread(f,buffer,1000,Xferred);
     XFOK := buffer[Xferred-1] = $ff;
    finally
     closefile(f);
    end;

    if XFOK then
     begin
      form1.msglabel.Caption := 'file opened: ' + fname;
      form1.Caption := formheader + fname;
     end
      else begin
            form1.msglabel.Caption := 'read error';
            exit;
           end;
    s := '';
    for i := 0 to 6 do s := s + chr(buffer[i]);
    if s <> fileheader then begin
                             form1.msglabel.Caption := 'format error';
                             exit;
                            end;
    gamesize := buffer[7];
    bix := 8;
    for j := 1 to gamesize do
     for i := 1 to gamesize do
      with game[i,j] do
       begin
        ftype := TfieldType(buffer[bix]);
        brCount := buffer[bix+1];
        //0,0
        inc(bix,4);
       end;
       newGameLoaded; //-->unit1
   end;//if execute
end;

end.


