unit Unit1;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    StaticText1: TStaticText;
    UpDown1: TUpDown;
    Label1: TLabel;
    searchBtn: TBitBtn;
    PaintBox1: TPaintBox;
    clearBtn: TBitBtn;
    msglabel: TLabel;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    Label2: TLabel;
    Label3: TLabel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure searchBtnClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

var counter : array[1..16] of byte; //combinations counter
    p : byte;                       //index of counter position
    count : byte;                   //number of 1's placed
    maxcount : byte;                //the highest digit, counting from 1...
    CCresult : byte;                //comb. counter result 0: end; 1: solution
    combination : byte;

procedure showcounter;
//paint counter in paintbox1
var i : byte;
    r : Trect;
    s : string;
begin
with form1.paintbox1 do with canvas do
 begin
  brush.style := bsSolid;
  for i := 1 to 8 do
   begin
    r := rect((i-1)*30+1,1,i*30-1,height-1);
    fillrect(r);
    s := inttostr(counter[i]);
    textout((i-1)*30+10,5,s);
   end;
  if p > 0 then
   begin
    pen.Width := 2;
    pen.color := $ff0000;
    brush.Style := bsClear;
    ellipse((p-1)*30+4,2,p*30-4,26);
   end;
 end;
end;

function combinations(n,k : byte) : dword;
//calculate number of combinations
var i : byte;
    x : double;
begin
 x := 1;
 for i := 1 to n-k do x := x * (i+k)/i;
 result := round(x);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i : byte;
begin
 with paintbox1 do with canvas do
  begin
   pen.Color := $0;
   pen.Width := 1;
   brush.Color := $ffffff;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
   moveto(0,0);
   lineto(0,height-1);
   lineto(width-1,height-1);
   lineto(width-1,0);
   lineto(0,0);
   for i := 0 to 8 do
    begin
     moveto(i*30,0);
     lineto(i*30,height);
    end;
  showcounter;
  end;
end;

function advance : byte;
label loop,Ladd,Lshift,Lback;
begin

Loop:

 if p = 8 then goto Lback;
 if count = maxcount then goto Lshift;

Ladd:

 inc(p);
 counter[p] := 1;
 inc(count);
 if count = maxcount then begin
                           result := 1;
                           exit;
                          end;
 goto loop;

Lshift:

  counter[p] := 0;
  inc(p);
  counter[p] := 1;
  result := 1;
  exit;

Lback:

  counter[p] := 0;
  dec(count);
  while (p > 0) and (counter[p] = 0) do dec(p);
  if p = 0 then begin
                 result := 0;
                 exit;          //report end
                end;
  counter[p] := 0;
  inc(p);
  counter[p] := 1;
  if (8-p) < maxcount - count then goto LBack; //no space for next digits
  goto Loop;
end;

procedure TForm1.searchBtnClick(Sender: TObject);
//advance combinations counter
begin
 if CCresult = 0 then exit;
 CCresult := advance;
 case CCresult of
  0 : msglabel.Caption := 'end.';
  1 : begin
       inc(combination);
       msglabel.Caption := 'solution';
      end;
 end;//case
 showcounter;
 statictext2.Caption := inttostr(combination);
end;

procedure TForm1.clearBtnClick(Sender: TObject);
//clear
var i : byte;
    x : dword;
begin
 activecontrol := nil;
 CCresult := 1;
 for i := 1 to 16 do counter[i] := 0;
 paintbox1.Invalidate;
 p := 0;
 count := 0;
 maxcount := UpDown1.Position;
 msglabel.Caption := 'counter cleared, max. bridges set';
 showcounter;
 x := combinations(8,maxcount);
 statictext3.Caption := inttostr(x);
 statictext2.Caption := '';
 combination := 0;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
 clearBtnClick(self);
end;

end.
